program _12_que_fill;
{$APPTYPE CONSOLE}
{
      11 
 ..   .. .
  6.
   12. .  
   Delphi.  
}

uses
  SysUtils, Windows;

const XMAX = 5;
      YMAX = 5;
      NEW_COLOR = 2;
type
     TPoint = record
       x, y: integer;
     end;
     TQueue = record
       data: array of TPoint;
       size: integer;
     end;
var Q: TQueue;
    x0, y0, color: integer;
    A: array[1..yMAX,1..xMAX] of integer;
    pt: TPoint;
    F: Text;
    i, j: integer;

function Point(x, y: integer): TPoint;
var P: TPoint;
begin
  P.x := x;
  P.y := y;
  Point := P;
end;

procedure Put(var Q: TQueue; x: TPoint);
begin
  if Q.size > High(Q.data) then
    SetLength(Q.data, High(Q.data)+11);
  Q.data[Q.size]:=x;
  Q.size:=Q.size + 1;
end;

function Get(var Q:TQueue): TPoint;
var i: integer;
begin
  Get:=Q.data[0];
  Q.size:=Q.size-1;

for i:=0 to Q.Size-1 do
     Q.data[i]:=Q.data[i+1];
end;

procedure ShowQueue(var Q:TQueue);
var i: integer;
begin
  for i:=0 to Q.Size-1 do
     write('(', Q.data[i].x, ',', Q.data[i].y, ') ');
  writeln;
end;

function isEmpty(Q: TQueue): boolean;
begin
  isEmpty := (Q.size = 0);
end;

procedure ShowMatrix;
var i, j: integer;
begin
  writeln('--------------------');
  for i:=1 to YMAX do begin
    for j:=1 to XMAX do
      write(A[i,j]:3);
    writeln;
  end;
  writeln('--------------------');
end;

begin
  //     CP1251 (Windows-1251).
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);
  //        , 
  //     (    ),  "".
  //       ""    : "Lucida Console".

  Assign(F, 'input_map.dat');
  Reset(F);
  for i:=1 to YMAX do begin
    for j:=1 to XMAX do
      read(F, A[i,j]);
  end;
  writeln ( ' :' );
  ShowMatrix;

  SetLength(Q.data, 0);
  Q.size:=0;

  y0:=1; x0:=2;
  color:=A[y0,x0];
  Put(Q, Point(x0,y0));

  writeln(' :');
  ShowQueue(Q);

  while not isEmpty(Q) do begin
    pt:=Get(Q);
    if A[pt.y,pt.x] = color then begin
      A[pt.y,pt.x] := NEW_COLOR;
      if pt.x > 1 then Put(Q, Point(pt.x-1,pt.y));
      if pt.y > 1 then Put(Q, Point(pt.x,pt.y-1));
      if pt.x < XMAX then Put(Q, Point(pt.x+1,pt.y));
      if pt.y < YMAX then Put(Q, Point(pt.x,pt.y+1));
    end;
    ShowQueue(Q);
  end;

  writeln ( '  :' );
  ShowMatrix;

  readln;

end.
