program dynProgFib;
{
 Программа к учебнику информатики для 11 класса
 К.Ю. Полякова и Е.А. Еремина.
 Глава 6.
 Программа № 18. Динамическое программирование.
                 Числа Фибоначчи
}
uses DOS;

const N = 45;

var F: array[1..N] of longint;
    i, t0, t1, FN: longint;
    f1, f2: longint;

function Fib(N: longint): longint;
begin
  if N < 3 then Fib:=1
  else Fib:= Fib(N-1) + Fib(N-2);
end;

function time: longint;
var h, m, s, ms: word;
begin
  gettime(h, m, s, ms);
  time:= ms + 100*(s + 60*(m + 60*h))
end;

begin

  writeln('Вычисляется F(', N, ') ...');

  t0:=time;
  FN := Fib(N);
  t1:=time;
  writeln('Рекурсивная функция:');
  writeln('  F(', N, ') = ', FN, ', время ', (t1-t0)/100:0:2, ' с');

  t0:=time;
  F[1]:=1; F[2]:=1;
  for i:=3 to N do
   F[i] := F[i-1] + F[i-2];
  t1:=time;
  writeln('Итерация с хранением данных в массиве');
  writeln('  F(', N, ') = ', F[N], ', время ', (t1-t0)/100:0:2, ' с');

  t0:=time;
  f2:=1; f1:=1;
  for i:=3 to N do begin
    FN := f1 + f2;
    f2 := f1;
    f1 := FN;
  end;
  t1:=time;
  writeln('Итерация без массива');
  writeln('  F(', N, ') = ', F[N], ', время ', (t1-t0)/100:0:2, ' с');
  readln;
end.
