program dynProgStones;
{
 Программа к учебнику информатики для 11 класса
 К.Ю. Полякова и Е.А. Еремина.
 Глава 6.
 Программа № 19. Динамическое программирование.
                 Задача о куче
}
const WMAX = 8;
      NStones = 4;
var T: array[1..NStones,0..WMAX] of longint;
    P: array[1..NStones] of integer;
    w, i, w0, t0, t1: integer;

function max(a, b: integer):integer;
begin
  if a > b then
       max:=a
  else max:=b;
end;

procedure showTable;
var i, w: integer;
begin
  write(' ':3);
  for w:=0 to WMAX do write(w:3);
  writeln;
  write('---');
  for i:=0 to WMAX do write('---');
  writeln;
  for i:=1 to NStones do begin
    write(P[i]:2,':');
    for w:=0 to WMAX do
      write(T[i,w]:3);
    writeln;
  end;
  writeln;
end;

begin


  P[1]:=2; P[2]:=4; P[3]:=5; P[4]:=7;
  for i:=1 to NStones do T[i,0]:=0;
  for w:=P[1] to WMAX do T[1,w]:=P[1];

  for i:=2 to NStones do
    for w:=1 to WMAX do begin
      t0 := T[i-1,w];
      if w >= P[i] then begin
        t1 := T[i-1,w-P[i]] + P[i];
        T[i,w] := max(t0, t1);
      end
      else T[i,w] := t0;
    end;

  showTable;

  writeln('Оптимальное решение: w = ', T[NStones,WMAX]);
  writeln('Берем камни: ');
  i := NStones;
  w := WMAX;
  w0 := T[NStones,WMAX];
  while w0 > 0 do begin
    while (i > 0) and (T[i,w] = w0) do
      Dec(i);
    if i = 0 then begin
      write(w0);
      break;
    end;
    write(P[i+1], ' ');
    w0 := w0 - P[i+1];
    w := w0;
  end;

  readln;

end.
