unit WordList;
{
 Программа к учебнику информатики для 11 класса
 К.Ю. Полякова и Е.А. Еремина.
 Глава 6.
 Программа № 9. Алфавитно-частотный словарь
 Модуль для работы с алфавитно-частотным словарем.
 Версия для PascalABC.NET.
}

interface

type TPair = record
       word: string;
       count: integer;
     end;
     TWordList = record
       data: array of TPair;
       size: integer;
     end;

function Find(L: TWordList; word: string): integer;
function FindPlace(L: TWordList; word: string): integer;
procedure InsertWord(var L: TWordList; k: integer; word: string);

procedure printList(L: TWordList);

implementation

function Find(L: TWordList; word: string): integer;
var i: integer;
begin
  Find:=-1;
  for i:=0 to L.size-1 do
    if L.data[i].word = word then begin
      Find:=i;
      break;
    end;
end;

function FindPlace(L: TWordList; word: string): integer;
var i, p: integer;
begin
  p:=-1;
  for i:=0 to L.size-1 do
    if L.data[i].word > word then begin
      p:=i;
      break;
    end;
  if p < 0 then p := L.size;
  FindPlace:= p;
end;

procedure printList(L: TWordList);
var i: integer;
begin
  for i:=0 to L.size-1 do
    writeln(L.data[i].word, ': ', L.data[i].count );
end;

procedure IncSize(var L: TWordList);
begin
  L.size := L.size + 1;
  if L.size > Length(L.data) then
    SetLength(L.data, Length(L.data)+10);
end;

procedure InsertWord(var L: TWordList; k: integer; word: string);
var i: integer;
begin
  IncSize(L);
  for i:=L.size-1 downto k+1 do
    L.data[i] := L.data[i-1];
  L.data[k].word := word;
  L.data[k].count := 1;
end;

end.
