program graphFloyd;
{
 ணࠬ  祡 ଠ⨪  11 
 .. 类  .. ६.
  6.
 ணࠬ  17. . 砩訥 .
                  -襫
}

const ASCII = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
      INF = 30000;

var W, P: array of array of integer;
    N, i, j, k: integer;

procedure ReadWeightMatrix;
var F: Text;
    i, j: integer;
begin
  Assign(F, 'input_graphs.dat');
  Reset(F);

  readln(F, N);
  SetLength(W, N+1, N+1);
  SetLength(P, N+1, N+1);

  writeln ( 'ᮢ  : ' );
  write('    ');
  for j:=1 to N do write(ASCII[j]:4);
  writeln;
  write('----');
  for j:=1 to N do write('----');
  writeln;
  for i:=1 to N do begin
    write(ASCII[i]:2, ' |');
    for j:=1 to N do begin
      read(F, W[i,j]);
      if W[i,j] < 0 then begin
        W[i,j] := INF;
        write('   .');
      end
      else write(W[i,j]:4);
    end;
    readln(F);
    writeln;
  end;
  Close(F);
  writeln;
end;

begin

  ReadWeightMatrix;

  for i:=1 to N do begin
    for j:=1 to N do
      P[i,j] := i;
    P[i,i] := 0;
  end;

  for k:= 1 to N do
    for i:= 1 to N do
      for j:= 1 to N do
        if W[i,k] + W[k,j] < W[i,j] then begin
           W[i,j]:= W[i,k] + W[k,j];
           P[i][j]:= P[k][j];
        end;

  writeln(' 砩 ﭨ:');
  write('    ');
  for j:=1 to N do write(ASCII[j]:4);
  writeln;
  write('----');
  for j:=1 to N do write('----');
  writeln;
  for i:=1 to N do begin
    write(ASCII[i]:2, ' |');
    for j:=1 to N do begin
      if W[i,j] = INF then
           write ( '   .' )
      else write(W[i,j]:4);
    end;
    writeln;
  end;

  writeln;
  writeln('ᯮ⥫쭠 :');
  write('    ');
  for j:=1 to N do write(ASCII[j]:4);
  writeln;
  write('----');
  for j:=1 to N do write('----');
  writeln;
  for i:=1 to N do begin
    write(ASCII[i]:2, ' |');
    for j:=1 to N do begin
      write(P[i,j]:4);
    end;
    writeln;
  end;

  writeln;
  for i:=1 to N do begin
    writeln('砩訥   設 ', ASCII[i], ':');
    for k:=1 to N do
      if k <> i then begin
        j := k;
        while j <> 0 do begin
          write(ASCII[j]:2);
          if j <> i then
            write(' <- ');
          j:=P[i,j];
        end;
        writeln;
      end;
  end;

  readln

end.
