program calcTree;
{
      11 
 ..   .. .
  6.
   13. .   
   PascalABC.NET.
}

type
  PNode = ^TNode;
  TNode = record
    data: string[20];
    left, right: PNode;
  end;

function Priority(op:char): integer;
begin
  case op of
    '+','-': Priority:=1;
    '*','/': Priority:=2;
    else Priority:=100;
  end;
end;

function LastOp(s: string): integer;
var i, minPrt: integer;
begin
  minPrt:=50;
  LastOp := 0;
  for i:=1 to Length(s) do
    if Priority(s[i]) <= minPrt then begin
      minPrt:=Priority(s[i]);
      LastOp := i;
    end;
end;

function MakeTree(s: string): PNode;
var k: integer;
    Tree: PNode; 
begin
   New(Tree);
   k:= LastOp(s);
   if k = 0 then begin
     Tree^.data := s;
     Tree^.left := nil;
     Tree^.right := nil;
   end
   else begin
     Tree^.data := s[k];
     Tree^.left := MakeTree(Copy(s,1,k-1));
     Tree^.right := MakeTree(Copy(s,k+1,Length(s)-k));
   end;
   MakeTree := Tree;
end;

function Calc(Tree: PNode): integer;
var n1, n2, res: integer;
begin
  if Tree^.left = nil then
    Val(Tree^.data, Result, res)
  else begin
    n1:=Calc(Tree^.left);
    n2:=Calc(Tree^.right);
    case Tree^.data[1] of
      '+': Calc:=n1+n2;
      '-': Calc:=n1-n2;
      '*': Calc:=n1*n2;
      '/': Calc:=n1 div n2;
      else Calc:=MaxInt;
    end;
  end
end;

var T: PNode;
    s: string;

begin
  writeln ( '    :' );
  readln ( s );
  T:= MakeTree ( s );
  writeln ( ': ', Calc(T) );
end.
