program graphDjkstra;
{
      11 
 ..   .. .
  6.
   16. .  .  
   PascalABC.NET.
}

const ASCII = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
      INF = 30000;

var W: array of array of integer;
    active: array of boolean;
    R, P: array of integer;
    N, i, j, min, kMin: integer;  

procedure ReadWeightMatrix;
var F: Text;
    i, j: integer;
begin
  Assign(F, 'input_graphs.dat');
  Reset(F);
  readln(F, N);
  SetLength(W, N+1);
  for i:=0 to High(W) do
    SetLength(W[i], N+1);
  writeln ( '  : ' );
  write('    ');
  for j:=1 to N do write(ASCII[j]:4);
  writeln;
  write('----');
  for j:=1 to N do write('----');
  writeln;
  for i:=1 to N do begin
    write(ASCII[i]:2, ' |');
    for j:=1 to N do begin
      read(F, W[i,j]);
      if W[i,j] < 0 then begin
        W[i,j] := INF;
        write('   .');
      end
      else write(W[i,j]:4);
    end;
    readln(F);
    writeln;
  end;
  Close(F);
  writeln;
end;

begin
  ReadWeightMatrix;

  SetLength(active, N+1);
  SetLength(R, N+1);
  SetLength(P, N+1);

  active[1] := False;
  R[1]:=0;
  P[1]:=0;
  for i:=2 to N do begin
    active[i] := True;
    R[i] := W[1,i];
    P[i] := 1;
  end;
  
  for i:=1 to N-1 do begin
    min := MaxInt;    
    for j:=1 to N do
      if active[j] and (R[j] < min) then begin
       min := R[j];
       kMin := j;
      end;
    active[kMin] := False;
    for j:=1 to N do
      if R[kMin]+W[kMin,j] < R[j] then begin
        R[j] := R[kMin]+W[kMin,j];
        P[j] := kMin;
      end;
  end;

  writeln(' :');
  write('   ');
  for i:=1 to N do write(ASCII[i]:5);
  writeln;
  write('---');
  for i:=1 to N do write('-----');
  writeln;
  write('R |');
  for i:=1 to N do write(R[i]:5);
  writeln;
  write('P |');
  for i:=1 to N do write(P[i]:5);
  writeln;

  writeln;
  writeln('    A   ', ASCII[N], ':');
  i := N;
  while i <> 0 do begin
    write(ASCII[i]:2);
    if i <> 1 then
      write(' <- ');
    i:=P[i];
  end;

end.
