program ReverseArray;
{
 Программа к учебнику информатики для 11 класса
 К.Ю. Полякова и Е.А. Еремина.
 Глава 6.
 Программа № 10. Реверс массива из файла
}

type TStack = record
       data: array of integer;
       size: integer;
     end;

var F: text;
    S: TStack;
    x, i: integer;

procedure InitStack(var S: TStack);
begin
  SetLength(S.data, 0);
  S.size := 0;
end;

procedure Push(var S: TStack; x: integer);
begin
  if S.size > High(S.data) then
    SetLength(S.data, High(S.data)+11);
  S.data[S.size]:=x;
  S.size:=S.size + 1;
end;

function Pop(var S:TStack): integer;
begin
  S.size:=S.size-1;
  Pop:=S.data[S.size];
end;

begin
  Assign(F, 'input_arr.dat');
  Reset(F);
  InitStack(S);
  while not eof(F) do begin
    read(F, x);
    Push(S, x);
  end;
  Close(F);
 
  Assign(F, 'output_arr.dat');
  Rewrite(F);
  for i:=0 to S.size-1 do begin
    x:=Pop(S);
    writeln(F,x);
  end;
  Close(F);

  writeln;
  writeln('Результат записан в файл output_arr.dat');
  readln;
end.
