program calcTree;
{
 Программа к учебнику информатики для 11 класса
 К.Ю. Полякова и Е.А. Еремина.
 Глава 6.
 Программа № 13. Деревья. Вычисление арифметических выражений
}

type
  PNode = ^TNode;
  TNode = record
    data: string[20];
    left, right: PNode;
  end;

function Priority(op:char): integer;
begin
  case op of
    '+','-': Priority:=1;
    '*','/': Priority:=2;
    else Priority:=100;
  end;
end;

function LastOp(s: string): integer;
var i, minPrt: integer;
begin
  minPrt:=50;
  LastOp := 0;
  for i:=1 to Length(s) do
    if Priority(s[i]) <= minPrt then begin
      minPrt:=Priority(s[i]);
      LastOp := i;
    end;
end;

function Tree(s: string): PNode;
var k: integer;
begin
   New(Tree);
   k:= LastOp(s);
   if k = 0 then begin
     Tree^.data := s;
     Tree^.left := nil;
     Tree^.right := nil;
   end
   else begin
     Tree^.data := s[k];
     Tree^.left := Tree(Copy(s,1,k-1));
     Tree^.right := Tree(Copy(s,k+1,Length(s)-k));
   end;
end;

function Calc(Tree: PNode): integer;
var n1, n2, res: integer;
begin
  if Tree^.left = nil then
    Val(Tree^.data, Calc, res)
  else begin
    n1:=Calc(Tree^.left);
    n2:=Calc(Tree^.right);
    case Tree^.data[1] of
      '+': Calc:=n1+n2;
      '-': Calc:=n1-n2;
      '*': Calc:=n1*n2;
      '/': Calc:=n1 div n2;
      else Calc:=MaxInt;
    end;
  end
end;

var T: PNode;
    s: string;

begin
  writeln ( 'Введите арифметическое выражение без скобок:' );
  readln ( s );
  T:= Tree ( s );
  writeln ( 'Результат: ', Calc(T) );
  readln;
end.
